#ifndef SNPINGENOME_H
#define SNPINGENOME_H

#include <string>
#include <vector>
#include <iostream>

#include "SNPatChr.h"
#include "binomialdistr.h"

#define ERROR_PER_POS 0.01

class SNPinGenome
{
    public:
        SNPinGenome(std::string const& inFile);
        virtual ~SNPinGenome();
        void assignValues(std::string const& inFile, std::string inputFormat,int minimalTotalLetterCountPerPosition);

        int findIndex (std::string chromosome);
        SNPatChr SNP_atChr(int);
    protected:
    private:
        std::vector <SNPatChr> SNP_atChr_;
        float addInfoFromAPileUp (int totalLetterCount, int minimalTotalLetterCountPerPosition,char whatToLook,
                                  int index,int &positionCount, int &sNPpositionToProceed,const char * pileup); //returns BAF in case on heterozygous SNP (NA otherwise)
        void processPileUPLine(int & positionCount, std::string line, std::string & oldChr, int & sNPpositionToProceed,int minimalTotalLetterCountPerPosition, int & index);
};

#endif // SNPINGENOME_H
