/*************************************************************************
Copyright (c) 2010-2011, Valentina BOEVA.

>>> SOURCE LICENSE >>>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation (www.fsf.org); either version 2 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A copy of the GNU General Public License is available at
http://www.fsf.org/licensing/licenses

>>> END OF LICENSE >>>
*************************************************************************/

#include "SNPposition.h"

SNPposition::SNPposition(int position, std::string letters, std::string strand, std::string ref)
{
    position_=position;
    std::vector<std::string> strs = split(letters, '/');

    if (strand.compare("-")==0) {
        ref[0] = complement(ref[0]);
    }
    if (strs[0][0]==ref[0]) {
        nucleotide_ = strs[1][0];
    } else {
        nucleotide_=strs[0][0];
    }

    if (strand.compare("-")==0) {
        nucleotide_ = complement(nucleotide_);
    }

    strs.clear();
}

SNPposition::~SNPposition()
{
    //dtor
}

int SNPposition::getPosition() {
    return position_;
}

char SNPposition::getNucleotide() {
    return nucleotide_;
}

void SNPposition::setFrequency(float freq) {
        freq_ = freq;
}

void SNPposition::setStatus(float status) {
        status_ = status;
}

float SNPposition::getValue() {
    return freq_ ;
}

float SNPposition::getStatus() {
    return status_ ;
}
